---
title: Create User Group
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[IAM](https://developers.cloudflare.com/api/go/resources/iam)

[User Groups](https://developers.cloudflare.com/api/go/resources/iam/subresources/user_groups)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create User Group

client.IAM.UserGroups.New(ctx, params) (\*[UserGroupNewResponse](<https://developers.cloudflare.com/api/go/resources/iam#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/iam/user\_groups

Create a new user group under the specified account.

##### Security

API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**`X-Auth-Email: user@example.com`

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**`X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194`

##### Accepted Permissions (at least one required)

`SCIM Provisioning``Account Settings Write`

##### ParametersExpand Collapse

<details>

<summary>

params UserGroupNewParams

</summary>

AccountID param.Field\[string]

Path param: Account identifier tag.

maxLength32

minLength32

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

Name param.Field\[string]

Body param: Name of the User group.

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20name">Link to this property</a>

<details>

<summary>

Policies param.Field\[\[]UserGroupNewParamsPolicy]Optional

Body param: Policies attached to the User group

</summary>

<details>

<summary>

Access UserGroupNewParamsPoliciesAccess

Allow or deny operations against the resources.

</summary>

One of the following:

const UserGroupNewParamsPoliciesAccessAllow UserGroupNewParamsPoliciesAccess = "allow"

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20policies%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20access%20%3E%20(member)%200">Link to this property</a>

const UserGroupNewParamsPoliciesAccessDeny UserGroupNewParamsPoliciesAccess = "deny"

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20policies%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20access%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20policies%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20access">Link to this property</a>

<details>

<summary>

PermissionGroups \[]UserGroupNewParamsPoliciesPermissionGroup

A set of permission groups that are specified to the policy.

</summary>

ID string

Permission Group identifier tag.

maxLength32

minLength32

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20policies%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20policies%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20permission_groups">Link to this property</a>

<details>

<summary>

ResourceGroups \[]UserGroupNewParamsPoliciesResourceGroup

A set of resource groups that are specified to the policy.

</summary>

ID string

Resource Group identifier tag.

maxLength32

minLength32

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20policies%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20policies%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20resource_groups">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20policies">Link to this property</a>

</details>

[Link to this property](<#(resource)%20iam.user_groups%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type UserGroupNewResponse struct{…}

A group of policies resources.

</summary>

ID string

User Group identifier tag.

maxLength32

minLength32

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

CreatedOn Time

Timestamp for the creation of the user group

formatdate-time

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20created_on">Link to this property</a>

ModifiedOn Time

Last time the user group was modified.

formatdate-time

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20modified_on">Link to this property</a>

Name string

Name of the user group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

<details>

<summary>

Policies \[]UserGroupNewResponsePolicyOptional

Policies attached to the User group

</summary>

ID stringOptional

Policy identifier.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

Access UserGroupNewResponsePoliciesAccessOptional

Allow or deny operations against the resources.

</summary>

One of the following:

const UserGroupNewResponsePoliciesAccessAllow UserGroupNewResponsePoliciesAccess = "allow"

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20access%20%3E%20(member)%200">Link to this property</a>

const UserGroupNewResponsePoliciesAccessDeny UserGroupNewResponsePoliciesAccess = "deny"

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20access%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20access">Link to this property</a>

<details>

<summary>

PermissionGroups \[]UserGroupNewResponsePoliciesPermissionGroupOptional

A set of permission groups that are specified to the policy.

</summary>

ID string

Identifier of the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

Meta UserGroupNewResponsePoliciesPermissionGroupsMetaOptional

Attributes associated to the permission group.

</summary>

Category stringOptional

A category used to group permission groups.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20category">Link to this property</a>

Deprecated stringOptional

Indicates whether the permission group is deprecated.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20deprecated">Link to this property</a>

Description stringOptional

Additional information about the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20description">Link to this property</a>

Editable stringOptional

Indicates whether the permission group can be edited.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20editable">Link to this property</a>

EolAt TimeOptional

The planned end-of-life date and time, when provided.

formatdate-time

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20eol_at">Link to this property</a>

Label stringOptional

A label identifying the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20label">Link to this property</a>

Scopes stringOptional

The scope associated with the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20scopes">Link to this property</a>

Visibility stringOptional

Indicates the permission group’s availability or visibility.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20visibility">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20meta">Link to this property</a>

Name stringOptional

Name of the permission group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups%20%3E%20(items)%20%3E%20(property)%20name">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20permission_groups">Link to this property</a>

<details>

<summary>

ResourceGroups \[]UserGroupNewResponsePoliciesResourceGroupOptional

A list of resource groups that the policy applies to.

</summary>

ID string

Identifier of the resource group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

Scope UserGroupNewResponsePoliciesResourceGroupsScope

A scope is a combination of scope objects which provides additional context.

</summary>

Key string

This is a combination of pre-defined resource name and identifier (like Account ID etc.)

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20scope%20%3E%20(property)%20key">Link to this property</a>

<details>

<summary>

Objects \[]UserGroupNewResponsePoliciesResourceGroupsScopeObject

A list of scope objects for additional context.

</summary>

Key string

This is a combination of pre-defined resource name and identifier (like Zone ID etc.)

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20scope%20%3E%20(property)%20objects%20%3E%20(items)%20%3E%20(property)%20key">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20scope%20%3E%20(property)%20objects">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20scope">Link to this property</a>

<details>

<summary>

Meta UserGroupNewResponsePoliciesResourceGroupsMetaOptional

Attributes associated to the resource group.

</summary>

Key stringOptional

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20key">Link to this property</a>

Value stringOptional

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20meta%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20meta">Link to this property</a>

Name stringOptional

Name of the resource group.

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups%20%3E%20(items)%20%3E%20(property)%20name">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies%20%3E%20(items)%20%3E%20(property)%20resource_groups">Link to this property</a>

</details>

<a href="#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)%20%3E%20(property)%20policies">Link to this property</a>

</details>

[Link to this property](<#(resource)%20iam.user_groups%20%3E%20(model)%20UserGroupNewResponse%20%3E%20(schema)>)

### Create User Group

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/iam"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"),
    option.WithAPIEmail("user@example.com"),
  )
  userGroup, err := client.IAM.UserGroups.New(context.TODO(), iam.UserGroupNewParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    Name: cloudflare.F("My New User Group"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", userGroup.ID)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "023e105f4ecef8ad9ca31a8372d0c353",
    "created_on": "2024-03-01T12:21:02Z",
    "modified_on": "2024-03-01T12:21:02Z",
    "name": "My New User Group",
    "policies": [
      {
        "id": "f267e341f3dd4697bd3b9f71dd96247f",
        "access": "allow",
        "permission_groups": [
          {
            "id": "c8fed203ed3043cba015a93ad1616f1f",
            "meta": {
              "category": "category",
              "deprecated": "deprecated",
              "description": "description",
              "editable": "editable",
              "eol_at": "2019-12-27T18:11:19.117Z",
              "label": "load_balancer_admin",
              "scopes": "com.cloudflare.api.account",
              "visibility": "visibility"
            },
            "name": "Zone Read"
          },
          {
            "id": "82e64a83756745bbbb1c9c2701bf816b",
            "meta": {
              "category": "category",
              "deprecated": "deprecated",
              "description": "description",
              "editable": "editable",
              "eol_at": "2019-12-27T18:11:19.117Z",
              "label": "fbm_user",
              "scopes": "com.cloudflare.api.account",
              "visibility": "visibility"
            },
            "name": "Magic Network Monitoring"
          }
        ],
        "resource_groups": [
          {
            "id": "6d7f2f5f5b1d4a0e9081fdc98d432fd1",
            "scope": {
              "key": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4",
              "objects": [
                {
                  "key": "com.cloudflare.api.account.zone.23f8d65290b24279ba6f44721b3eaad5"
                }
              ]
            },
            "meta": {
              "key": "key",
              "value": "value"
            },
            "name": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4"
          }
        ]
      }
    ]
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "023e105f4ecef8ad9ca31a8372d0c353",
    "created_on": "2024-03-01T12:21:02Z",
    "modified_on": "2024-03-01T12:21:02Z",
    "name": "My New User Group",
    "policies": [
      {
        "id": "f267e341f3dd4697bd3b9f71dd96247f",
        "access": "allow",
        "permission_groups": [
          {
            "id": "c8fed203ed3043cba015a93ad1616f1f",
            "meta": {
              "category": "category",
              "deprecated": "deprecated",
              "description": "description",
              "editable": "editable",
              "eol_at": "2019-12-27T18:11:19.117Z",
              "label": "load_balancer_admin",
              "scopes": "com.cloudflare.api.account",
              "visibility": "visibility"
            },
            "name": "Zone Read"
          },
          {
            "id": "82e64a83756745bbbb1c9c2701bf816b",
            "meta": {
              "category": "category",
              "deprecated": "deprecated",
              "description": "description",
              "editable": "editable",
              "eol_at": "2019-12-27T18:11:19.117Z",
              "label": "fbm_user",
              "scopes": "com.cloudflare.api.account",
              "visibility": "visibility"
            },
            "name": "Magic Network Monitoring"
          }
        ],
        "resource_groups": [
          {
            "id": "6d7f2f5f5b1d4a0e9081fdc98d432fd1",
            "scope": {
              "key": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4",
              "objects": [
                {
                  "key": "com.cloudflare.api.account.zone.23f8d65290b24279ba6f44721b3eaad5"
                }
              ]
            },
            "meta": {
              "key": "key",
              "value": "value"
            },
            "name": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4"
          }
        ]
      }
    ]
  }
}
```